/******************************************************************************/
/* Blinky.c: LED Flasher and graphic demo                                     */
/******************************************************************************/
/* This file is part of the uVision/ARM development tools.                    */
/* Copyright (c) 2005-2009 Keil Software. All rights reserved.                */
/* This software may only be used under the terms of a valid, current,        */
/* end user licence from KEIL for a compatible version of KEIL software       */
/* development tools. Nothing else gives you the right to use this software.  */
/******************************************************************************/
                  
#include <LPC17xx.H>                    				//NXP LPC17xx definitions 
#include "LCD.h"
#include "string.h"
#include "sys.h"
#include "lcd.h"
#include "touch.h"
#include "exti.h"
#include "I2C.H"
#include "hardware_conf.h"
#include "ov7670.h"	

u8 buf1[32];
/*   */
u8 i=0;
u32 m=0;   //б
u16 Camera_Data = 0,temp1 = 0;
extern u8 VsyncCnt;
//extern unsigned char gImage_p[];
/*
*********************************************************************************************************
* Description: 	The function is setting font colorsbrush colors and the area of clear
* Arguments  : 	None
* Returns    : 	None
*********************************************************************************************************
*/
void Load_Drow_Dialog(void)
{
	LCD_Clear(WHITE);   
 	POINT_COLOR=Red;									//Setting font colors 
	LCD_ShowString(216,0,"RST");						//Displaying screen clear area
  	POINT_COLOR=RED;									//Setting brush color 
}
/*
*********************************************************************************************************
* Description: 	Delay function
* Arguments  : 	The time of ms
* Returns    : 	None
*********************************************************************************************************
*/
static __inline void Delay1ms(unsigned int delay1msdata)
{
	unsigned int i,j,k;
	for(i=0;i<delay1msdata;i++)
		for(j=0;j<1000;j++)
			for(k=0;k<100;k++)
		;
}

static __inline void Camera_RESET(void)
{
  	FIFO_WRST =0;	//дָ븴λ
  	DelayNS(200);
  	FIFO_WRST =1;
  	DelayNS(1);
  	FIFO_RRST =0;	//ָ븴λ
  	DelayNS(1);
	FIFO_RCLK =0;	//Ҫһʱڵܸλ
  	DelayNS(1);
	FIFO_RCLK =1;
  	DelayNS(1);
	FIFO_RCLK =0;	//Ҫһʱڵܸλ
  	DelayNS(1);
	FIFO_RCLK =1;
  	DelayNS(200);
  	FIFO_RRST =1;
}
static __inline void Camera_Display(void)
{
		  LCD_SetDisplayWindow(0, 0, 239, 319);
 		  LCD_CS(0);
  		  LCD_WriteRAM_Prepare();
		  LCD_CS(0);
          LCD_RS(1);
			for(m = 0; m <76800; m++)	//QVGAʽ,240;ÿ320		
			{
				FIFO_RCLK =0;
				__nop();	
				FIFO_RCLK =1;
				__nop();
				Camera_Data = FIFO_DATA_PIN;	//ȶ8λ            
		
				FIFO_RCLK =0;
				__nop();
				FIFO_RCLK =1;
				__nop();
				LCD_DIR(1)		   				//Interface A->B
  				LCD_EN(0)	                        //Enable 2A->2B
				LPC_GPIO2->FIOPIN = FIFO_DATA_PIN;  //λ
			    LCD_LE(1)                         
  				LCD_LE(0)							//latch D0..D7
				LPC_GPIO2->FIOPIN = Camera_Data;  //λ
				LCD_WR(0)
  				__nop();
  				LCD_WR(1)							 
			}
			LCD_CS(1);
			__nop();
			FIFO_RRST =0;				//ָ븴λ										
			__nop();
			for(i=0;i<128;i++)		
			{
				FIFO_RCLK =0;				//Ҫһʱڵܸλ
				__nop();
				FIFO_RCLK =1;
				__nop();
			}
			FIFO_RRST =1;
			__nop();
//			FIFO_WEN =0;					//ֲ˵,λʱWENҪø, 
			FIFO_WRST =0;				//MCUWENHREF߼							
		 	__nop();					//AL422B,MCUWENõ422WENһΪ
										//дָ븴λҪһʱ	
			DelayNS(2);				    //ʱͼ׷ֿ
			FIFO_WRST =1;	   
			__nop();
			VsyncCnt = 0;				//ʼһ֡ݲɼ	   
			__nop();
}
/*
*********************************************************************************************************
* Description: 	Main function
* Arguments  : 	None
* Returns    : 	None
*********************************************************************************************************
*/
int main (void)                       
{
	SystemInit();
	EINTInit();
	LCD_Init   ();
	LCD_Clear  (Black);
	Camera_Configuration();		//ͷ

	/* LCD ʾ */		
//	LCD_Bmp(0, 0,319, 239, gImage_p);	  		//97ֱ99ΪͼƬĸ߶ȺͿ
	LCD_ShowString(20,270,"LandTiger board text!");	//320-180 140		 
	LCD_ShowString(20,290,"OV7670 Init......");
  	Delay1ms(100);
	Camera_RESET();
  	while (1)
  	{
     	if(OV7660_init()) break;	 //OV7660_init()==1ʼɹwhileѭ
	 	
  	}
	LCD_ShowString(20,290,"OV7670 Init......OK"); 
  	Delay1ms(200);
	set_qvga();

	while (1)
  	{
		if(VsyncCnt == 2)
  	   	{
		 	Camera_Display();
		}
	}

}


